require_dependency "gdrive/application_controller"

module Gdrive
  class DriveController < ApplicationController
    require 'google/apis/drive_v3'
    require 'google/api_client/client_secrets'

    def index
      client_secrets = Google::APIClient::ClientSecrets.load
      auth_client = client_secrets.to_authorization
      auth_client.update!(
        :scope => 'https://www.googleapis.com/auth/drive.file',
        :redirect_uri => Gdrive.mount_url
      )

      if request["code"] == nil
        session["redirect_url"] = params[:redirect_url]
        @auth_uri = auth_client.authorization_uri.to_s
        redirect_to @auth_uri
      else
        auth_code = params[:code]
        auth_client.code = auth_code
        begin
          auth_client.fetch_access_token!
          secret_hash = auth_client.as_json.slice("expiry", "refresh_token", "access_token")
          if secret_hash["refresh_token"] == nil
            @error = 'You have already authorized this application. In order to re-configure, go to <a href="https://myaccount.google.com/permissions">https://myaccount.google.com/permissions</a> and revoke access to "Standard File".'
          else
            secret_hash[:expires_at] = auth_client.expires_at
            secret = Base64.encode64(secret_hash.to_json)
            @secret_url = CGI.escape("#{Gdrive.mount_url}/sync?key=#{secret}")
            redirect_to "#{session["redirect_url"]}&gdrive_secret_url=#{@secret_url}"
          end
        rescue
          redirect_to(Gdrive.mount_url)
        end
      end
    end
  end
end
